#!/usr/local/bin/perl

print "Content-type: text/html", "\n\n"  ;

require ChatSign ;
require TimeUtilities ;
$data_basedir=&ChatSign::data_basedir ;
$URLdir_executables=&ChatSign::URLdir_executables ;

$request_method=$ENV{'REQUEST_METHOD'} ;

if ($request_method eq "GET") {
	$query_string=$ENV{'QUERY_STRING'} ;
	exit (1) ;
} else {
	$size_of_form=$ENV{'CONTENT_LENGTH'} ;
	read(STDIN, $query_string, $size_of_form) ;
}

# Split the name-value pairs
@pairs = split(/&/, $query_string);

foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	# Un-Webify plus signs and %-encoding
	$value =~ tr/+/ /;
	# Get rid of all non-alpha/numeric stuff esp " ' ,
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	# $value =~ s/['|"|`|,]//g;
	# Stop people from using subshells to execute commands
	# when using UCB mail (aka mailx).
	$value =~ s/~!/ ~!/g;
	$FORM{$name}=$value ;
}

# Now get a list of legit sites
$sites="$data_basedir/websites.dat" ;
open (SITES,$sites) || die "Cannot open $sites\n" ;
chomp ;
while (<SITES>) {
	chomp ;
	($site,$password,$default_email)=split(/,/) ;
	$sites{$site}=$site ;
	$default_emails{$site}=$default_email ;
}

print <<ENUF;
<HEAD>
<TITLE>
ChatSign - Email Chat to $FORM{domain}
</TITLE>
</HEAD>
<BODY>
<PRE>
<CENTER>
<H3>Hello $FORM{domain}</H3>

A copy of your chat with $FORM{requestor} has been
emailled to $default_emails{$FORM{domain}}.

</BODY>
</HTML>
ENUF

($pretty_date, $pretty_time)=&TimeUtilities::make_unixtime_readable($now) ;

$mailprog = '/usr/lib/sendmail';

$recipient=$default_emails{$FORM{domain}} ;
open (MAIL, "|$mailprog $recipient") || die "Can't open $mailprog!\n";
print MAIL <<ENUF ;
From: chat\@chatsign.com (ChatSign Chats)
To: $recipient 
Subject: A copy of your chat with $FORM{requestor}

ENUF

open (CHAT,"$data_basedir/$FORM{domain}/chats/$FORM{requestor}") || die "Cannot open chat\n" ;
while (<CHAT>) {
	($who,$when,$what)=split(/\^/) ;
	($pretty_date, $pretty_time)=&TimeUtilities::make_unixtime_readable($when) ;
	print MAIL "$who - $pretty_date $pretty_time - $what\n" ;
}


print <<ENUF;


Regards
ChatSign


ENUF
close (MAIL) ;

exit (0) ;
